unit BulletInfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

// -> 1 = Explosion
// -> 2 = BlackHole
// -> 3 = AntiBlackHole
// -> 4 = Bazooka

type
  TBulletInfo = class(TObject)
    public
      constructor Create(fn, pow : Integer);
      fn_id : Integer;
      x, y : Integer;
      power : Integer;
  end;

  TBulletInfoStack = class(TObject)
    public
      constructor Create;
      procedure Push(b : TBulletInfo);
      function Pop : TBulletInfo;

      function Empty : Boolean;

    private
      S : array[0..1024] of TBulletInfo;
      size : Integer;
  end;

var
  BIS : TBulletInfoStack;

implementation

constructor TBulletInfo.Create(fn, pow : Integer);
begin
  fn_id := fn;
  power := pow;
end;

constructor TBulletInfoStack.Create;
begin
  size := 0;
end;
procedure TBulletInfoStack.Push(b : TBulletInfo);
begin
  if(size < 1023) then begin
    S[size] := b;
    Inc(size, 1);
  end;
end;
function TBulletInfoStack.Pop : TBulletInfo;
begin
  if(size > 0) then begin
    Result := S[size - 1];
    Dec(size, 1);
  end;
end;
function TBulletInfoStack.Empty : Boolean;
begin
  Result := (size = 0);
end;

end.

