unit Change;

{
  this class changes some other classes (in ParticleSystem of cours Particles)

  receiver -> class to be changed
  sender   -> class who tells that Receiver must be changed
  time_diff-> how long ago (in seconds) last tried to change, (automatically computed in Alternation.ApplyAlternations)

  for example:
  --killer (sender) tells to all in radius (receiver) that they must die...
  implementation : Alternation(TBoolTrue.Create, TSelectorCircle.Create(42), TChangeKill.Create)

  --move by velocity (see TChangeMove in ParticleChange)
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  TChange = class
    public
      constructor Create;
      destructor Destroy; override;

      //for DeletionList (in Alternation)
      procedure Evaluate; virtual;
      function IsDead : Boolean; virtual;

      //change Receiver (optional : use data from Sender), time_diff <=> how much
      // ! this class should be overriden in sucessors
      procedure Apply(
        receiver : TObject;
        sender : TObject = nil;
        time_diff : Real = 0
      ); virtual;
  end;

implementation

// ------------------------- TChange -------------------

constructor TChange.Create;
begin

end;
destructor TChange.Destroy;
begin
  inherited;
end;

procedure TChange.Evaluate;
begin

end;

function TChange.IsDead : Boolean;
begin
  Result := false; //invincible man
end;

procedure TChange.Apply(receiver, sender : TObject; time_diff : Real);
begin

end;

end.

