unit MyGraphics;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics;

//procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer); overload;
//procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer; color_min, color_max: Integer); overload;
procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer;
  color_min_r : Integer = 255; color_min_g : Integer = 0  ; color_min_b : Integer = 0  ;
  color_max_r : Integer = 0  ; color_max_g : Integer = 255; color_max_b : Integer = 0  ;
  color_bg : Integer = 13158600; color_border : Integer = 0
);

implementation

{
procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer);
begin
  DrawProgressBar(img, value, max, fx, fy, tx, ty, RgbToColor(255,0,0), RgbToColor(0,255,0));
end;

procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer; color_min, color_max: Integer);
begin
  DrawProgressBar(img, value, max, fx, fy, tx, ty, color_min, color_max, RgbToColor(200,200,200), RgbToColor(0,0,0));
end;
}

procedure DrawProgressBar(img : TBitmap; value, max : Real; fx,fy,tx,ty : Integer;
  color_min_r : Integer; color_min_g : Integer; color_min_b : Integer;
  color_max_r : Integer; color_max_g : Integer; color_max_b : Integer;
  color_bg : Integer; color_border : Integer
);
var
 ratio : Real;
 color : Integer;
begin
  if value < 0.0 then value := 0;
  ratio := value/max;

 img.Canvas.Brush.Color := color_bg;
 img.Canvas.Pen.Color := color_border;
 img.Canvas.Rectangle(fx, fy, tx, ty);

 color :=  RgbToColor(
   color_min_r + Round(ratio * Real(color_max_r - color_min_r)),
   color_min_g + Round(ratio * Real(color_max_g - color_min_g)),
   color_min_b + Round(ratio * Real(color_max_b - color_min_b))
 );
 img.Canvas.Brush.Color := color;
 img.Canvas.Pen.Color := color;
 img.Canvas.Rectangle(fx+1, fy+1, fx + 1 + Round(ratio*Real(tx-fx-2)), ty-1);
end;

end.

