unit MyTime;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

var
  _Time : Integer;

type
  //uses MyTime
  TMyTime = class
    public
      constructor Create;

      function updateTime : Real; //in seconds (calls reset time to)
      function diffTime : Real;      //in seconds
      function diffTimeMs : Integer;      //in miliseconds
      procedure resetTime;
      procedure addTimeMs(x : Integer); //in miliseconds
    private
      last_changed : Integer;
  end;

implementation

constructor TMyTime.Create;
begin
  resetTime;
end;

function TMyTime.updateTime : Real;
begin
  Result := diffTime;
  resetTime;
end;

function TMyTime.diffTime : Real;
begin
  Result := Real(diffTimeMs) / 1000.0;
end;
function TMyTime.diffTimeMs : Integer;
begin
  Result := _Time - last_changed;
end;

procedure TMyTime.resetTime;
begin
  last_changed := _Time;
end;

procedure TMyTime.addTimeMs(x : Integer); //in miliseconds
begin
  last_changed := last_changed + x;
end;

end.

